@@ -25,12 +25,14 @@
 import java.util.ListIterator;
 import java.util.Locale;
 import java.util.Map;
 import java.util.TimeZone;
 import java.util.regex.PatternSyntaxException;
 
+import javax.script.ScriptException;
+
 import javolution.util.FastList;
 import javolution.util.FastMap;
 
 import org.ofbiz.base.util.Debug;
 import org.ofbiz.base.util.GeneralException;
 import org.ofbiz.base.util.ObjectType;
@@ -272,18 +274,30 @@
         }
     }
 
     public static class Script extends ModelFormAction {
         protected String location;
         protected String method;
+        protected String value;
+        protected String type;
 
         public Script(ModelForm modelForm, Element scriptElement) {
             super (modelForm, scriptElement);
             String scriptLocation = scriptElement.getAttribute("location");
             this.location = WidgetWorker.getScriptLocation(scriptLocation);
             this.method = WidgetWorker.getScriptMethodName(scriptLocation);
+            if (UtilValidate.isNotEmpty(scriptLocation)){
+                this.location = WidgetWorker.getScriptLocation(scriptLocation);
+                this.method = WidgetWorker.getScriptMethodName(scriptLocation);
+            } else {
+                this.value = scriptElement.getAttribute("value");
+                this.type = scriptElement.getAttribute("type");
+            }
+            if (UtilValidate.isEmpty(this.location) && UtilValidate.isEmpty(this.value) ) {
+               throw new IllegalArgumentException("Cannot specify a script whithout location and value property, one of the two is mandatory, on  action in a form widget");
+            }
         }
 
         @Override
         public void runAction(Map<String, Object> context) {
             if (location.endsWith(".xml")) {
                 Map<String, Object> localContext = FastMap.newInstance();
@@ -293,12 +307,18 @@
                 try {
                     SimpleMethod.runSimpleMethod(location, method, methodContext);
                     context.putAll(methodContext.getResults());
                 } catch (MiniLangException e) {
                     throw new IllegalArgumentException("Error running simple method at location [" + location + "]", e);
                 }
+            } else if (UtilValidate.isNotEmpty(value)) {
+                try {
+                    ScriptUtil.executeGroovyScript(value, context);
+                } catch (ScriptException e) {
+                    e.printStackTrace();
+                }
             } else {
                 ScriptUtil.executeScript(this.location, this.method, context);
             }
         }
     }
 
